/* Sivann '99 */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/time.h>
#include <time.h>
#include <signal.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdlib.h>
#include <fcntl.h>
#include <errno.h>
#include <unistd.h>


int	numofchildren=0;
void 	childhdl(int);
void	remove_shm();
int	pick_next();
int 	create_shm();
int	child=0;
char	playlist[256];

typedef struct {
  off_t offset;		/*current offset*/
  off_t offsets[256];	/*children's offsets*/
  char 	fname[256];	/*song playing*/
  int 	serial;		/*serial number of song*/
  int 	filepos;	/*current file position in playlist*/
} stream_info_s;

stream_info_s * sip ;

/*shm stuff*/
key_t 	key;
int   	shmid;
char  	*segptr;
size_t 	segsize=sizeof(stream_info_s);

serve_client(int Asd)
{
  fd_set inout_fds;
  char buff[8196];
  char tmp[512];
  char tmp2[256];
  int r,w,i,fd;
  int count=0;
  int myserial;
  char myfname[256];
  int id=0,ppid,pid;
  
  
  id=numofchildren;
  ppid=getppid();
  pid=getpid();

  /*negotiate data types*/
  r=read(Asd,buff,1024);
  buff[r]=0;
#ifdef DEBUG
  printf("pid:%d:read from client:#%s#\n",pid,buff);
#endif
  if (r<=0) {
    shutdown(Asd, 2);
    close(Asd);
#ifdef DEBUG
    printf("pid:%d:read failed socket..exiting\n",pid);
#endif
    exit(0);
  }

  sprintf(tmp,"HTTP/1.1 200 OK\n"
	       "Server: sivanns-musicserver/0.1\n"
	       "Connection: close\n"
	       "Content-Type: audio/mpeg\n");

  if (strstr(buff,"Icy-MetaData")) {
    sprintf(tmp2,"icy-name:%s\nicy-br:128\n",sip->fname);
    strcat(tmp,tmp2);
  }

  strcat(tmp,"\n");
  write(Asd,tmp,strlen(tmp));

  if (strstr(buff,"HEAD")) {
    shutdown(Asd, 2);
    close(Asd);
    exit(0);
  }

    
  /*enter song-service loop*/
  while (1)
  {
    /*Get current song and serial of this song*/
    myserial=sip->serial;
    strcpy(myfname,sip->fname);
    count=0;

#ifdef DEBUG
    printf("pid:%d,serving[%d]:%s\n",pid,myserial,myfname);
#endif

    fd=open(myfname,O_RDONLY);
    if (fd<0) {
      fprintf(stderr,"open %s: %s\n",myfname,strerror(errno));
      exit(-4);
    }
    
    /*pre-buffering adjustment*/
    if (sip->offset>120000) {
      lseek(fd,sip->offset-120000,SEEK_SET);
      count=(sip->offset-120000)/8196;
    }
    else if (sip->offset) {
      lseek(fd,sip->offset,SEEK_SET);
      count=(sip->offset)/8196;
    }

    while((r=read(fd,buff,8196))>0 && (w=write(Asd,buff,r))>0) {
      count++;
      if (count*8196 > sip->offset && myserial==sip->serial)
	sip->offset=count*8196;	/*we need a semaphore here*/
#ifdef DEBUG
	printf("pid:%d,my offset:%d,global offset:%d\n",
	  pid,count*8196,sip->offset);
#endif
    }

    if (r<=0) { 			/*song finished normaly*/
      if (myserial == sip->serial)	/*we are ahead of the others*/
	kill(ppid,SIGUSR1);		/*tell the parent to change the song*/
    }
    if (w<0) {
      shutdown(Asd, 2);
      close(Asd);
#ifdef DEBUG
      printf("pid:%d:write failed on socket..exiting\n",pid);
#endif
      exit(0);
    }

    close(fd);
#ifdef DEBUG
    printf("pid:%d wrote the hole file, r:%d, w:%d\n",pid,r,w);
#endif

    while ( sip->serial == myserial ) sleep(1); /*wait the song to change*/
  }
}

void my_exit()
{
  if (!child) {
    printf("\nExiting...\n");
    remove_shm();
  }
}

void usr1hdl(int pid)
{
#ifdef DEBUG
  printf("%d:usr1hdl\n",getpid());
#endif
  pick_next();
  signal(SIGUSR1, usr1hdl);
}

void childhdl(int pid)
{
int i,r;

  while((r=waitpid(-1,&i,WNOHANG))>0) 
    numofchildren--;

#ifdef DEBUG
  printf("%d:childhandler:child %d died,children:%d \n",getpid(),
	    r, numofchildren);
#endif
  signal(SIGCHLD, childhdl);
}

pick_next()
{
  FILE *fp;
  int i;
  char tmp[256];
  
  if (!(fp=fopen(playlist,"r"))) {
    perror(playlist);
    exit(errno);
  }
      
  for (i=0;i<sip->filepos+1;i++) {
    if (!fgets(tmp,255,fp)) {
      if (i) {
	sip->filepos=0;
	fseek(fp,0,SEEK_SET);
	fgets(tmp,255,fp) ;
	break;
      }
      else {
	fprintf(stderr,"%s: is empty\n",playlist);
	exit(1);
      }
    }

  }

  tmp[strlen(tmp)-1]=0; 	/*chop*/
  strcpy(sip->fname,tmp);
  sip->offset=0;
  sip->filepos++;
  sip->serial++;
  printf("pick_next:serial:%d, filepos:%d\n",sip->serial,sip->filepos);
}

create_shm()
{

  /* Create unique key via call to ftok() */
  key = ftok(".", 'M');

  /* Open the shared memory segment - create if necessary */
  if((shmid = shmget(key, segsize, IPC_CREAT|IPC_EXCL|0666)) == -1) 
  {
    printf("Shared memory segment exists - opening as client\n");

    /* Segment probably already exists - try as a client */
    if((shmid = shmget(key, segsize, 0)) == -1) 
    {
      perror("shmget");
      exit(1);
    }
  }
  else
    printf("Created new shared memory segment\n");
  

  /* Attach (map) the shared memory segment into the current process */
  if((sip = (stream_info_s *) shmat(shmid, 0, 0)) <0)
  {
    perror("shmat");
    exit(1);
  }
  sip->offset=0;
  sip->serial=0;
  sip->filepos=0;
}


void remove_shm()
{
  shmctl(shmid, IPC_RMID, 0);
  printf("Shared memory segment marked for deletion\n");
}

main(int argc,char **argv)
{
  int           one = 1, i,f,sel;
  struct 	sockaddr_in sa;
  char          buff[1024];
  int           Asd, len, lsd;
  fd_set        inout_fds;
  int 		port;
	
  struct timeval  tval;

  if (argc!=3) {
    fprintf(stderr,"Usage: musicserver <port> <file-with-mp3s>\n");
    exit(0);
  }
  
  port=atoi(argv[1]);
  strncpy(playlist,argv[2],256);

  if ((lsd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    perror("socket");
    exit(1);
  }

  setsockopt(lsd, SOL_SOCKET, SO_REUSEADDR, (char *) &one, sizeof(one));
  sa.sin_family = AF_INET;
  sa.sin_port = htons((u_short) port);
  sa.sin_addr.s_addr = htonl(INADDR_ANY);

  if (bind(lsd, (struct sockaddr *) & sa, sizeof(sa)) < 0) {
    perror("bind");
    exit(2);
  }

  if (listen(lsd, 1) < 0) {
    perror("listen");
    exit(3);
  }
  len = sizeof(sa);

  signal(SIGCHLD, childhdl);
  signal(SIGINT,  exit);
  signal(SIGUSR1, usr1hdl);
  
  create_shm();		/*Initialize shared memory*/
  
  //memcpy(segptr,sip,sizeof(stream_info_s));

  atexit(my_exit);

  tval.tv_sec = 0; 	/* seconds */
  tval.tv_usec = 0;	/* microseconds */

  printf("Entering main loop\n");

  pick_next();

  while (1) {

    FD_ZERO(&inout_fds);
    FD_SET(lsd, &inout_fds);


    do {
      sel=select(16,&inout_fds,(fd_set *) 0, (fd_set *) 0, 
	  (struct timeval *) 0/*&tval*/);
#ifdef DEBUG
      printf("select:%d\n",sel);
#endif
      if (sel==-1 && numofchildren==0) {
	/*goto next song*/
	printf("Adeiasame\n");
	pick_next();
      };

    } while (sel<0);
    
    printf("After select\n");
    printf("\ncurrent offset sip->offset:%d\n",sip->offset);
    if (FD_ISSET(lsd,&inout_fds)) {
      if (f=fork()) {
	numofchildren++;
	printf("New connection (%d), children:%d\n",f,numofchildren);
      }
      else { /*child*/
	numofchildren++;
	child=1;
	if ((Asd = accept(lsd, (struct sockaddr *) & sa, &len)) < 0) {
	  perror("accept");
	  exit(4);
	}
	serve_client(Asd);
	printf("serve_client %d exited\n",getpid());
	exit(0);
      } /*child*/
    }
    if (sel==0) { /*timeout - update buffer if needed*/
      
    }

  } /*while (1) */
}
